#include "types.h"
#include "parse.h"
#include "select.h"
#include "sort.h"
#include "show.h"
#include "error.h"
#include "stdio.h"
#include "stdlib.h"

int main()
{
  fieldname selectfields[32]={0}; //      
  int selectfieldsidx[32]={0}; //       (    )
  int selectfieldscount;
  fieldname orderfield={0}; //     
  //   (       ,  
  //      selectfieldsidx.
  int orderfieldidx;
  //  -     .
  tablename tbls[32]={0};

  const int datamaxsize=32768;
  int datasize=0;
  field *data=(field*)malloc(sizeof(field)*datamaxsize);

  //char cmdline[1024]="select header2,header3,header1 from base.csv,base3.csv order by header3";
  char cmdline[1024]="select * from simple.txt order by SEQN";
  char outputname[260]="baseout.csv";

  printf("enter select:\n");
  //_gets(cmdline,sizeof(cmdline));
  printf("enter output file:\n");
  //_gets(outputname,sizeof(outputname));

  TRACE("parse\n");
  if(!parse(selectfields,sizeof(selectfields)/sizeof(fieldname),tbls,sizeof(tbls)/sizeof(tablename),&orderfield,cmdline))
    goto error;
  TRACE("parse '%s' '%s' '%s' '%s'\n",selectfields,tbls,orderfield,cmdline);

  TRACE("normalizeparams %08x\n",normalizeparams);
  if(!normalizeparams(selectfields,&orderfield,tbls,selectfieldsidx,&selectfieldscount,&orderfieldidx))
    goto error;

  TRACE("select\n");
  if((datasize=select(selectfieldsidx,selectfieldscount,tbls,data,datamaxsize))==-1)
    goto error;
  TRACE("select %d\n",datasize);

  TRACE("sort\n");
  if(sort(data,datasize,selectfieldsidx,selectfieldscount,orderfieldidx))
    goto error;

  TRACE("show\n");
  if(!show(data,selectfieldsidx,selectfieldscount,orderfieldidx,outputname))
    goto error;

  free(data);
	return 0;
error:
  free(data);
  printf("Stage fatal error: '%s'\n",geterror());
  return 1;
}

// select * from adfas order by 1,2

/*
I parse  
II load   
III sort 
IV 

fields
table
orders
*/
